## fp16 0.0~git20200412.3c54eac

=== debian/changelog ===
fp16 (0.0~git20200412.3c54eac-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 12:30:42 +0800

fp16 (0.0~git20200412.3c54eac-2) unstable; urgency=medium

  * Add the missing Expat license. Thanks to FTP-Masters.
  * Apply wrap-and-sort.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 29 Apr 2020 08:07:34 +0800

fp16 (0.0~git20200412.3c54eac-1) experimental; urgency=medium

  * Initial release (Closes: #958650)

 -- Mo Zhou <lumin@debian.org>  Tue, 28 Apr 2020 11:55:44 +0800
