=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DGOOGLETEST_SOURCE_DIR=/usr/src/googletest

override_dh_auto_test:
	dh_auto_test
	#-find . -type f -executable -name '*bench' -exec '{}' \;

override_dh_auto_install:
	dh_auto_install
	-$(RM) -rf debian/libfp16-dev/usr/lib
	-$(RM) -rf debian/libfp16-dev/usr/include/gmock
	-$(RM) -rf debian/libfp16-dev/usr/include/gtest
	-find debian/libfp16-dev -name '*.py' -delete
