## fp16 0.0~git20200514.4dfe081

=== debian/changelog ===
fp16 (0.0~git20200514.4dfe081-5) unstable; urgency=medium

  * Team upload.

  [ Petter Reinholdtsen ]
  * Added ftbfs-gcc-14.patch to use required 'include <iomanip>' where needed.
    (Closes: #1077426)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Dylan Aïssi <daissi@debian.org>  Tue, 20 Aug 2024 17:47:04 +0200

fp16 (0.0~git20200514.4dfe081-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

  [ Mo Zhou ]
  * control: fix overlength description.

 -- Mo Zhou <lumin@debian.org>  Fri, 18 Aug 2023 14:15:14 -0400

fp16 (0.0~git20200514.4dfe081-3) unstable; urgency=medium

  * Fix i386 FTBFS with patch. (Closes: #996702)
  * d/copyright: Fix superfluous file pattern (lintian).

 -- Mo Zhou <lumin@debian.org>  Sun, 09 Jan 2022 12:20:10 -0500

fp16 (0.0~git20200514.4dfe081-2) unstable; urgency=medium

  * Change maintainer mail address to <debian-ai@l.d.o>.
  * Please pin to this upstream snapshot for PyTorch 1.7.0.

 -- Mo Zhou <lumin@debian.org>  Thu, 29 Oct 2020 13:31:11 +0800

fp16 (0.0~git20200514.4dfe081-1) unstable; urgency=medium

  * New upstream version 0.0~git20200514.4dfe081
  * Maintainer is Debian Deep Learning Team

 -- Mo Zhou <lumin@debian.org>  Mon, 31 Aug 2020 11:13:52 +0800

fp16 (0.0~git20200412.3c54eac-3) unstable; urgency=medium

  * Bump debhelper compat level to 13.
  * Don't remove the .py files from -dev package (required by rdepends).

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Apr 2020 22:57:14 +0800
