=== debian/control ===
Source: fp16
Section: math
Homepage: https://github.com/Maratyszcza/FP16
Priority: optional
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/deeplearning-team/fp16
Vcs-Git: https://salsa.debian.org/deeplearning-team/fp16.git
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Felix Salfelder <felix@salfelder.org>, Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               googletest,
               libbenchmark-dev,
               libpsimd-dev
Rules-Requires-Root: no

Package: libfp16-dev
Architecture: any
Depends: ${misc:Depends}
Description: Conversion to/from half-precision floating point formats
 Header-only library for conversion to/from half-precision floating point
 formats Features
 .
  + Supports IEEE and ARM alternative half-precision floating-point format
    - Property converts infinities and NaNs
    - Properly converts denormal numbers
  + Header-only library, no installation or build required
  + Compatible with C99 and C++11
  + Fully covered with unit tests and microbenchmarks
 .
 This is a header-only library.
